%define pkg_name boost
Name: boost1_54
Summary: The free peer-reviewed portable C++ source libraries
Version: 1.54.0
Release: 4%{?dist}
License: Boost and MIT and Python

URL: http://www.boost.org
Group: System Environment/Libraries

Source0: boost_1_54_0.tar.bz2

Requires: %{name}-atomic = %{version}-%{release}
Requires: %{name}-chrono = %{version}-%{release}
Requires: %{name}-context = %{version}-%{release}
Requires: %{name}-date-time = %{version}-%{release}
Requires: %{name}-filesystem = %{version}-%{release}
Requires: %{name}-graph = %{version}-%{release}
Requires: %{name}-iostreams = %{version}-%{release}
Requires: %{name}-locale = %{version}-%{release}
Requires: %{name}-log = %{version}-%{release}
Requires: %{name}-math = %{version}-%{release}
Requires: %{name}-program-options = %{version}-%{release}
Requires: %{name}-python = %{version}-%{release}
Requires: %{name}-random = %{version}-%{release}
Requires: %{name}-regex = %{version}-%{release}
Requires: %{name}-serialization = %{version}-%{release}
Requires: %{name}-signals = %{version}-%{release}
Requires: %{name}-system = %{version}-%{release}
Requires: %{name}-test = %{version}-%{release}
Requires: %{name}-thread = %{version}-%{release}
Requires: %{name}-timer = %{version}-%{release}
Requires: %{name}-wave = %{version}-%{release}

BuildRequires: m4
BuildRequires: libstdc++-devel%{?_isa}
BuildRequires: bzip2-devel%{?_isa}
BuildRequires: zlib-devel%{?_isa}
BuildRequires: python-devel%{?_isa}
BuildRequires: libicu-devel%{?_isa}

%description
Boost provides free peer-reviewed portable C++ source libraries.  The
emphasis is on libraries which work well with the C++ Standard
Library, in the hopes of establishing "existing practice" for
extensions and providing reference implementations so that the Boost
libraries are suitable for eventual standardization. (Some of the
libraries have already been included in the C++ 2011 standard and
others have been proposed to the C++ Standards Committee for inclusion
in future standards.)

%package atomic
Summary: Run-Time component of boost atomic library
Group: System Environment/Libraries

%description atomic

Run-Time support for Boost.Atomic, a library that provides atomic data
types and operations on these data types, as well as memory ordering
constraints required for coordinating multiple threads through atomic
variables.

%package chrono
Summary: Run-Time component of boost chrono library
Group: System Environment/Libraries
Requires: %{name}-system = %{version}-%{release}

%description chrono

Run-Time support for Boost.Chrono, a set of useful time utilities.

%package context
Summary: Run-Time component of boost context switching library
Group: System Environment/Libraries

%description context

Run-Time support for Boost.Context, a foundational library that
provides a sort of cooperative multitasking on a single thread.

%package date-time
Summary: Run-Time component of boost date-time library
Group: System Environment/Libraries

%description date-time

Run-Time support for Boost Date Time, set of date-time libraries based
on generic programming concepts.

%package filesystem
Summary: Run-Time component of boost filesystem library
Group: System Environment/Libraries
Requires: %{name}-system = %{version}-%{release}

%description filesystem

Run-Time support for the Boost Filesystem Library, which provides
portable facilities to query and manipulate paths, files, and
directories.

%package graph
Summary: Run-Time component of boost graph library
Group: System Environment/Libraries
Requires: %{name}-regex = %{version}-%{release}

%description graph

Run-Time support for the BGL graph library.  BGL interface and graph
components are generic, in the same sense as the the Standard Template
Library (STL).

%package iostreams
Summary: Run-Time component of boost iostreams library
Group: System Environment/Libraries

%description iostreams

Run-Time support for Boost.IOStreams, a framework for defining streams,
stream buffers and i/o filters.

%package locale
Summary: Run-Time component of boost locale library
Group: System Environment/Libraries
Requires: %{name}-chrono = %{version}-%{release}
Requires: %{name}-system = %{version}-%{release}
Requires: %{name}-thread = %{version}-%{release}

%description locale

Run-Time support for Boost.Locale, a set of localization and Unicode
handling tools.

%package log
Summary: Run-Time component of boost logging library
Group: System Environment/Libraries

%description log

Boost.Log library aims to make logging significantly easier for the
application developer.  It provides a wide range of out-of-the-box
tools along with public interfaces for extending the library.

%package math
Summary: Math functions for boost TR1 library
Group: System Environment/Libraries

%description math

Run-Time support for C99 and C++ TR1 C-style Functions from math
portion of Boost.TR1.

%package program-options
Summary:  Run-Time component of boost program_options library
Group: System Environment/Libraries

%description program-options

Run-Time support of boost program options library, which allows program
developers to obtain (name, value) pairs from the user, via
conventional methods such as command line and configuration file.

%package python
Summary: Run-Time component of boost python library
Group: System Environment/Libraries

%description python

The Boost Python Library is a framework for interfacing Python and
C++. It allows you to quickly and seamlessly expose C++ classes
functions and objects to Python, and vice versa, using no special
tools -- just your C++ compiler.  This package contains run-time
support for Boost Python Library.

%package random
Summary: Run-Time component of boost random library
Group: System Environment/Libraries

%description random

Run-Time support for boost random library.

%package regex
Summary: Run-Time component of boost regular expression library
Group: System Environment/Libraries

%description regex

Run-Time support for boost regular expression library.

%package serialization
Summary: Run-Time component of boost serialization library
Group: System Environment/Libraries

%description serialization

Run-Time support for serialization for persistence and marshaling.

%package signals
Summary: Run-Time component of boost signals and slots library
Group: System Environment/Libraries

%description signals

Run-Time support for managed signals & slots callback implementation.

%package system
Summary: Run-Time component of boost system support library
Group: System Environment/Libraries

%description system

Run-Time component of Boost operating system support library, including
the diagnostics support that will be part of the C++0x standard
library.

%package test
Summary: Run-Time component of boost test library
Group: System Environment/Libraries

%description test

Run-Time support for simple program testing, full unit testing, and for
program execution monitoring.

%package thread
Summary: Run-Time component of boost thread library
Group: System Environment/Libraries
Requires: %{name}-system = %{version}-%{release}

%description thread

Run-Time component Boost.Thread library, which provides classes and
functions for managing multiple threads of execution, and for
synchronizing data between the threads or providing separate copies of
data specific to individual threads.

%package timer
Summary: Run-Time component of boost timer library
Group: System Environment/Libraries
Requires: %{name}-chrono = %{version}-%{release}
Requires: %{name}-system = %{version}-%{release}

%description timer

"How long does my C++ code take to run?"
The Boost Timer library answers that question and does so portably,
with as little as one #include and one additional line of code.

%package wave
Summary: Run-Time component of boost C99/C++ pre-processing library
Group: System Environment/Libraries
Requires: %{name}-chrono = %{version}-%{release}
Requires: %{name}-date-time = %{version}-%{release}
Requires: %{name}-filesystem = %{version}-%{release}
Requires: %{name}-system = %{version}-%{release}
Requires: %{name}-thread = %{version}-%{release}

%description wave

Run-Time support for the Boost.Wave library, a Standards conforming,
and highly configurable implementation of the mandated C99/C++
pre-processor functionality.

%package devel
Summary: The Boost C++ headers and shared development libraries
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Provides: %{name}-python-devel = %{version}-%{release}
Requires: libicu-devel%{?_isa}

# Odeint was shipped in Fedora 18, but later became part of Boost.
# Note we also obsolete odeint-doc down there.
# https://bugzilla.redhat.com/show_bug.cgi?id=892850
Provides: odeint = 2.2-5
Obsoletes: odeint < 2.2-5
Provides: odeint-devel = 2.2-5
Obsoletes: odeint-devel < 2.2-5

%description devel
Headers and shared object symbolic links for the Boost C++ libraries.

%package static
Summary: The Boost C++ static development libraries
Group: Development/Libraries
Requires: %{name}-devel = %{version}-%{release}
Obsoletes: %{name}-devel-static < 1.34.1-14
Provides:  %{name}-devel-static = %{version}-%{release}

%description static
Static Boost C++ libraries.

%package doc
Summary: HTML documentation for the Boost C++ libraries
Group: Documentation
%if 0%{?fedora} >= 10 || 0%{?rhel} >= 6
BuildArch: noarch
%endif
Provides: %{name}-python-docs = %{version}-%{release}

# See the description above.
Provides: odeint-doc = 2.2-5
Obsoletes: odeint-doc < 2.2-5

%description doc
This package contains the documentation in the HTML format of the Boost C++
libraries. The documentation provides the same content as that on the Boost
web page (http://www.boost.org/doc/libs/1_40_0).

%package examples
Summary: Source examples for the Boost C++ libraries
Group: Documentation
%if 0%{?fedora} >= 10 || 0%{?rhel} >= 6
BuildArch: noarch
%endif
Requires: %{name}-devel = %{version}-%{release}

%description examples
This package contains example source files distributed with boost.

%package build
Summary: Cross platform build system for C++ projects
Group: Development/Tools
BuildArch: noarch

%description build
Boost.Build is an easy way to build C++ projects, everywhere. You name
your pieces of executable and libraries and list their sources.  Boost.Build
takes care about compiling your sources with the right options,
creating static and shared libraries, making pieces of executable, and other
chores -- whether you're using GCC, MSVC, or a dozen more supported
C++ compilers -- on Windows, OSX, Linux and commercial UNIX systems.

%prep
%setup -q -n boost_1_54_0

%build
./bootstrap.sh

%install
rm -rf $RPM_BUILD_ROOT
./b2 --prefix=$RPM_BUILD_ROOT --libdir=$RPM_BUILD_ROOT/%{_libdir}/%{name} --includedir=$RPM_BUILD_ROOT/%{_includedir}/%{name} install
mkdir -p $RPM_BUILD_ROOT/etc/ld.so.conf.d
echo "%{_libdir}/%{name}/" > $RPM_BUILD_ROOT/etc/ld.so.conf.d/%{name}-%{_arch}.conf

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
/etc/ld.so.conf.d/%{name}-%{_arch}.conf

%files atomic
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_atomic.so.%{version}

%files chrono
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_chrono.so.%{version}

%files context
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_context.so.%{version}

%files date-time
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_date_time.so.%{version}

%files filesystem
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_filesystem.so.%{version}

%files graph
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_graph.so.%{version}

%files iostreams
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_iostreams.so.%{version}

%files locale
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_locale.so.%{version}

%files log
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_log.so.%{version}
%{_libdir}/%{name}/libboost_log_setup.so.%{version}

%files math
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_math_c99.so.%{version}
%{_libdir}/%{name}/libboost_math_c99f.so.%{version}
%{_libdir}/%{name}/libboost_math_c99l.so.%{version}
%{_libdir}/%{name}/libboost_math_tr1.so.%{version}
%{_libdir}/%{name}/libboost_math_tr1f.so.%{version}
%{_libdir}/%{name}/libboost_math_tr1l.so.%{version}

%files test
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_prg_exec_monitor.so.%{version}
%{_libdir}/%{name}/libboost_unit_test_framework.so.%{version}

%files program-options
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_program_options.so.%{version}

%files python
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_python.so.%{version}

%files random
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_random.so.%{version}

%files regex
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_regex.so.%{version}

%files serialization
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_serialization.so.%{version}
%{_libdir}/%{name}/libboost_wserialization.so.%{version}

%files signals
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_signals.so.%{version}

%files system
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_system.so.%{version}

%files thread
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_thread.so.%{version}

%files timer
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_timer.so.%{version}

%files wave
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/libboost_wave.so.%{version}

%files doc
%defattr(-, root, root, -)
#%doc %{boost_docdir}/*

%files examples
%defattr(-, root, root, -)
#%doc %{boost_examplesdir}/*

%files devel
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_includedir}/%{name}
%{_libdir}/%{name}/libboost_atomic.so
%{_libdir}/%{name}/libboost_chrono.so
%{_libdir}/%{name}/libboost_context.so
%{_libdir}/%{name}/libboost_date_time.so
%{_libdir}/%{name}/libboost_filesystem.so
%{_libdir}/%{name}/libboost_graph.so
%{_libdir}/%{name}/libboost_iostreams.so
%{_libdir}/%{name}/libboost_locale.so
%{_libdir}/%{name}/libboost_log.so
%{_libdir}/%{name}/libboost_log_setup.so
%{_libdir}/%{name}/libboost_math_tr1.so
%{_libdir}/%{name}/libboost_math_tr1f.so
%{_libdir}/%{name}/libboost_math_tr1l.so
%{_libdir}/%{name}/libboost_math_c99.so
%{_libdir}/%{name}/libboost_math_c99f.so
%{_libdir}/%{name}/libboost_math_c99l.so
%{_libdir}/%{name}/libboost_prg_exec_monitor.so
%{_libdir}/%{name}/libboost_unit_test_framework.so
%{_libdir}/%{name}/libboost_program_options.so
%{_libdir}/%{name}/libboost_python.so
%{_libdir}/%{name}/libboost_random.so
%{_libdir}/%{name}/libboost_regex.so
%{_libdir}/%{name}/libboost_serialization.so
%{_libdir}/%{name}/libboost_wserialization.so
%{_libdir}/%{name}/libboost_signals.so
%{_libdir}/%{name}/libboost_system.so
%{_libdir}/%{name}/libboost_thread.so
%{_libdir}/%{name}/libboost_timer.so
%{_libdir}/%{name}/libboost_wave.so

%files static
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/*.a
%if %{with openmpi}
%{_libdir}/%{name}/openmpi/lib/*.a
%endif

# OpenMPI packages
%if %{with openmpi}

%files openmpi
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/openmpi/lib/libboost_mpi.so.%{version}

%files openmpi-devel
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/openmpi/lib/libboost_*.so

%files openmpi-python
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/openmpi/lib/libboost_mpi_python.so.%{version}
%{_libdir}/%{name}/openmpi/lib/mpi.so

%files graph-openmpi
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt
%{_libdir}/%{name}/openmpi/lib/libboost_graph_parallel.so.%{version}

%endif

# MPICH packages
%files build
%defattr(-, root, root, -)
%doc LICENSE_1_0.txt

%changelog
* Mon Jan 13 2014 Matt Robinson <mwr54@nbcs.rutgers.edu> 1.54.0-3
- Updated dependencies
- fixed dependencies spelling error

* Mon Jan 13 2014 Matt Robinson <mwr54@nbcs.rutgers.edu> 1.54.0-2
- Updated dependencies

* Wed Dec 18 2013 Matt Robinson <mwr54@nbcs.rutgers.edu> 1.54.0-1
- First build for Rutgers CentOS 6
